<?php
// Добавляем поддержку миниатюр
if (function_exists('add_theme_support')) {
	add_theme_support('post-thumbnails');
		set_post_thumbnail_size(9999, 9999);
}

// Энд-поинты приложения
add_action('rest_api_init', function() {

    // Маршрут авторизации
    register_rest_route('api/', 'auth/', [
		'methods'  => 'POST',
        'callback' => 'auth',
        'args' => array(
            'login' => array(
                'default' => $login
            ),
            'password' => array(
                'default' => $password
            ),
        ),
    ]);
    
    // Маршрут получения постов
    register_rest_route('api/', 'posts/', [
		'methods'  => 'POST',
        'callback' => 'getPosts',
        'args' => array(
            'id' => array(
                'default' => $id
            ),
            'type' => array(
                'default' => $type
            ),
            'counts' => array(
                'default' => $counts
            ),
        ),
	]);
});


// Функция авторизации пользователя
function auth($request) {

    // Вытаскиваем в отдельные переменные ключи из запроса
    $login = $request['login'];
    $password = $request['password'];

    // Проверяем пользователя
    $auth = wp_authenticate($login, $password);

    // Если ошибки нет
    if (!is_wp_error($auth)) {

        // Получаем id пользователя по email
        $user = get_user_by('email', $login);
        $user_ID = $user->data->ID;

        // Формируем объект ответа
        $response = array(
            "id" => $user_ID
        );
    
    // В случае ошибки
    } else {
        $response = array(
            "state" => 'error',
            "response" => 'Неправильный логин / пароль'
        );
    }
    
    // Возвращаем объект ответа
    return $response;
}


// Функция авторизации пользователя
function getPosts($request) {

    // Вытаскиваем в отдельные переменные ключи из запроса
    $id = $request['id'];
    $type = $request['type'];
    $counts = $request['counts'];

    // Если id передано
    if($id) {

        // Массив постов
        $posts = array();

        // Формируем запрос с помощью WP_Query
        $query = new WP_Query(array(
            'post_type' =>  $type,
            'posts_per_page' => $counts
        ));

        // Пройдемся по массиву
        while ($query->have_posts()) : $query->the_post();

            // Получаем заголовок и описание
            $title = esc_html(get_the_title());
            $desc = get_the_excerpt();
        
            // Получаем ссылку на изображение (если оно есть)
            if(has_post_thumbnail()) {
                $thumb_id = get_post_thumbnail_id();
                $thumb_cover_url = wp_get_attachment_image_src($thumb_id, full, true);
                $imgUrl = $thumb_cover_url[0];
            } else {
                $imgUrl = 'null'; // Или можно указать ссылку на картинку-заглушку
            }
        
            // Формируем объект поста
            $post = array(
                "title" => $title,
                "description" => $desc,
                "img" => $imgUrl
            );

            // Добавляем его в массив постов
            array_push($posts, $post);

        endwhile; wp_reset_postdata();

        // Ответ - это массив постов
        $response = $posts;

    // В случае, если id передано
    } else {
        $response = array(
            "state" => 'error',
            "response" => 'Мне нужен ID'
        );
    }

    
    // Возвращаем объект ответа
    return $response;
}
?>